/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2005-2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
package com.funambol.syncclient.ipod.panels;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextPane;
import javax.swing.UIManager;
import javax.swing.ImageIcon;
import javax.swing.text.MutableAttributeSet;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

import com.funambol.syncclient.ipod.MainWindow;
import com.funambol.syncclient.ipod.utils.Constants;
import com.funambol.syncclient.ipod.utils.Language;

/**
 * The about window.
 *
 * @version $Id: AboutPanel.java,v 1.5 2007-12-23 18:05:54 nichele Exp $
 */
public class AboutPanel extends JDialog implements ActionListener, Constants {
    public AboutPanel() {

    }

    // ------------------------------------------------------------ Private Data
    private MainWindow mainWindow;
    private JButton    jbuttonOk ;
    private JLabel     jLabel1   ;
    private JLabel     jLabel2   ;
    private JLabel     jLabel3   ;
    private JTextPane  jTextPane ;
    private JPanel     jPanel1   ;

    // ---------------------------------------------------------- Public Methods

    /** Creates new form JDialog */
    public AboutPanel(MainWindow mainWindow, boolean modal) {
        super(mainWindow, modal);
        this.mainWindow = mainWindow;
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     */
    private void initComponents() {
        int hlab  = 18 ;

        jPanel1 = new JPanel() ;
        jLabel1 = new JLabel() ;
        jLabel2 = new JLabel() ;
        jLabel3 = new JLabel() ;
        jTextPane = new JTextPane();
        jbuttonOk = new JButton()  ;

        try {
            UIManager.setLookAndFeel(Constants.lookAndFeel);
        } catch(Exception e) {
            e.printStackTrace();
        }

        //
        // Set up the window.
        //
        getContentPane().setLayout(null);

        setTitle(Language.getMessage(Language.LABEL_TITLE_ABOUT));
        setBackground(Color.WHITE);
        setForeground(Color.WHITE);
        setFont(FONT);
        setName("aboutDialog");
        setResizable(false);
        setSize(372,453);
        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setLocationRelativeTo(null);

        jPanel1.setLayout(null);
        jPanel1.setBackground(Color.WHITE);
        jPanel1.setForeground(Color.WHITE);
        jPanel1.setBounds(0, 0, 372, 453);
        getContentPane().add(jPanel1);

        JLabel lab = new JLabel(new ImageIcon(FRAME_LOGONAME));
        lab.setBounds(122, 6, 128, 128);
        jPanel1.add(lab);

        jLabel1.setBackground(Color.WHITE);
        jLabel1.setFont(FONT_BOLD);
        jLabel1.setText(Language.getMessage(Language.LABEL_ABOUT_IPOD_VERSION));
        jLabel1.setHorizontalAlignment(JLabel.CENTER);
        jLabel1.setBounds(86, 142, 200, hlab);
        jPanel1.add(jLabel1);

        jLabel2.setBackground(Color.WHITE);
        jLabel2.setFont(FONT);
        jLabel2.setText(Language.getMessage(Language.LABEL_ABOUT_COPYRIGHT));
        jLabel2.setHorizontalAlignment(JLabel.CENTER);
        jLabel2.setBounds(86, 167, 200, hlab);
        jPanel1.add(jLabel2);

        jLabel3.setBackground(Color.WHITE);
        jLabel3.setFont(FONT);
        jLabel3.setText(Language.getMessage(Language.LABEL_ABOUT_LINK));
        jLabel3.setHorizontalAlignment(JLabel.CENTER);
        jLabel3.setBounds(86, 192, 200, hlab);
        jPanel1.add(jLabel3);

        jTextPane.setEditable(false);
        jTextPane.setBackground(Color.WHITE);
        jTextPane.setBounds(12, 216, 343, hlab + 151);
        StyledDocument doc = jTextPane.getStyledDocument();
        //  Set alignment to be centered for all paragraphs
        MutableAttributeSet standard = new SimpleAttributeSet();
        StyleConstants.setAlignment(standard, StyleConstants.ALIGN_CENTER);
        StyleConstants.setFontSize(standard, 9);
        StyleConstants.setFontFamily(standard, "Microsoft Sans Serif");
        doc.setParagraphAttributes(0, 0, standard, true);
        jTextPane.setText(Language.getMessage(Language.LABEL_ABOUT_LICENSE));
        jPanel1.add(jTextPane);

        jbuttonOk.setBackground(Color.WHITE);
        jbuttonOk.setFont(FONT);
        jbuttonOk.setText(Language.getMessage(Language.BT_OK));
        jbuttonOk.setBounds(142, 390, 88, 24);
        jbuttonOk.addActionListener(this);
        jPanel1.add(jbuttonOk);

    }

    public void actionPerformed(ActionEvent evt) {
        removeAll();
        setVisible(false);
    }
}