/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2005 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
package com.funambol.syncclient.ipod.utils;

import java.io.File;
import java.util.ArrayList;
import org.apache.commons.io.filefilter.NameFileFilter;

/**
 *
 * @version $Id: Platform.java,v 1.4 2008-07-04 08:19:23 pauloslf Exp $
 */
public class Platform {
    //---------------------------------------------------------- Constants
    public static String os = System.getProperty("os.name");

    public static File[] getDrives() {
        File[] drives = null;
        ArrayList realDrives = null;
        String os = System.getProperty("os.name");
        if (os.startsWith("Windows")) {
            return File.listRoots();
        } else if (os.startsWith("Mac")) {
            drives = File.listRoots()[0].listFiles((java.io.FilenameFilter) new NameFileFilter("Volumes"))[0].listFiles();
            realDrives = new ArrayList();
            for (int i = 0; i < drives.length; i++) {
                if (!drives[i].getName().startsWith(".")) {
                    realDrives.add(drives[i]);
                }
            }
            return (File[]) realDrives.toArray(new File[realDrives.size()]);
        } else {
            // For linux systems only /mnt and /media folders are considered. 
            // Since the users can mount the iPod in _any_ path we consider these 
            // because they are the ones generaly used to automatically mount usb disks
            drives = File.listRoots()[0].listFiles();
            File[] realFolders = null;
            realDrives = new ArrayList();
            for (int i = 0; i < drives.length; i++) {
                if (!drives[i].getName().startsWith(".") &&
                        (drives[i].getName().toLowerCase().startsWith("media") ||
                        drives[i].getName().toLowerCase().startsWith("mnt"))) {
                    realFolders = drives[i].listFiles();
                    for (int x = 0; x < realFolders.length; x++) {
                        if (!realFolders[x].getName().startsWith(".")) {
                            realDrives.add(realFolders[x]);
                        }
                    }
                }

            }
            return (File[]) realDrives.toArray(new File[realDrives.size()]);
        }

    }
}


